<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – LDAP Authentication</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="ldap-authentication">LDAP Authentication</h1>
<p>Cacti supports using LDAP authentication to access the Cacti GUI. There are several different ways to use LDAP, which will be described in the following sections.</p>
<h2 id="be-aware">Be Aware</h2>
<p>When changing LDAP settings in Cacti, such as LDAP General Settings, LDAP Group Settings, and LDAP Specific Search Settings, you may notice that changes do not take effect immediately. You may need to close and reopen your web browser for some changes to take effect.</p>
<p>!! It would be good if someone could elaborate here on why this happens. !!</p>
<h2 id="defining-some-terms">Defining some terms</h2>
<p>Before proceeding, please ensure you are familiar with the following terms:</p>
<ol>
<li><p><em>LDAP</em> - A communication language, or protocol. It is a defined structure of how to ask questions of, and receive responses from, a directory. It also defines what questions there exist to be asked, and what responses there exist to be returned. LDAP is not a directory; it is a way to query a directory.</p></li>
<li><p><em>Directory</em> - A database of objects, accompanied with other attributes. Commonly, these objects are user identities, accompanied with passwords. Sometimes, the objects are groups, accompanied by a list of members. Usually the objects are stored in some type of hierarchical structure for organizational and management purposes.</p></li>
<li><p><em>DN</em> - Short for <em>distinguished name</em>, a string that represents a unique object in the directory. There can not be two DNs alike in a directory. In Microsoft's <em>Active Directory</em>, this is a string like 'CN=Joseph,OU=Accounting,OU=Users,DC=corp,DC=example,DC=com'.</p></li>
<li><p><em>Search</em> - A type of LDAP request, in which the client sends some criteria to the server in an attempt to receive back a list of directory objects that meet the search criteria.</p></li>
<li><p><em>Bind</em> - A type of LDAP request, in which the client sends the server a username and a password in an attempt to confirm whether the password is correct for that user.</p></li>
<li><p><em>sAMAccountName</em> - An attribute found in Microsoft's <em>Active Directory</em> directory, and is what we casually know as a <em>username</em>. The <em>sAMAccountName</em> does not uniquely represent an object in the Active Directory, whereas the <em>DN</em> does.</p></li>
</ol>
<h2 id="configuring-ldap">Configuring LDAP</h2>
<h3 id="ldap-general-settings">LDAP General Settings</h3>
<p><img src="images/ldap-settings.png" alt="LDAP Settings Page" /></p>
<h4 id="mode">Mode</h4>
<p>There are three basic routines that Cacti can execute when handling an LDAP authentication.</p>
<ol>
<li><em>No Searching</em> - In this routine, Cacti simply binds to the LDAP server using the credentials that were entered during login. Cacti performs a transformation upon the username before binding, that which is specified in the <em>Distinguished Name (DN)</em> field. This transformation is useful, for example, to add a fully-qualified domain name suffix, or to add a NetBIOS domain name prefix. For example:</li>
</ol>
<p><code>{username}@example.com</code></p>
<p>or</p>
<p><code>domain\{username}</code></p>
<ol start="2">
<li><p><em>Anonymous Searching</em> - In this routine, Cacti connects to LDAP with no authentication and attempts to perform a search for the <em>username</em>, in an attempt to retrieve the specific DN associated with the username. Once the specific DN of the username is found, Cacti binds to LDAP using the DN of the user and the password that was entered during login. Please note, by default, Microsoft's Active Directory does not permit anonymous searches, and will refuse the search request.</p></li>
<li><p><em>Specific Searching</em> - In this routine, Cacti binds to LDAP using a service account that was provided beforehand, then performs a search for the <em>username</em>, in an attempt to retrieve the specific DN associated with the username. Once the specific DN of the username is found, Cacti binds to LDAP using the DN of the user and the password that was entered during login.</p></li>
</ol>
<h4 id="encryption">Encryption</h4>
<ol>
<li><p><em>None</em> - This is plain-text, normally on port tcp/389. Passwords are transmitted over the network in clear text between Cacti and the directory.</p></li>
<li><p><em>SSL</em> - Commonly known as LDAPS, this is just like LDAP, but encrypted. This normally runs on port tcp/636. Please note, this is not enabled by default for Microsoft's Active Directory because it requires an encryption key and certificate to be installed on the AD controller(s).</p></li>
<li><p><em>TLS</em> - This is plain LDAP, but a START_TLS command is sent by the client to the server to initiate encryption. Normally runs on port tcp/389 and can be entered into during a regular LDAP session.</p></li>
</ol>
<p>Please note that some directories will limit the request types to which they respond when there is no encryption on the LDAP communication.</p>
<h4 id="referrals">Referrals</h4>
<p>An LDAP Referral is a field returned in an LDAP response message. The referral provides a list of alternate sources from which directory information can be obtained. In the case of a replicated directory such as Microsoft's Active Directory, the referral may contain an LDAP URL which could resolve to any participating LDAP server, whether correctly configured or not.</p>
<h3 id="ldap-group-settings">LDAP Group Settings</h3>
<p>Cacti can enforce that a user be a member of a specific directory group to be granted access to Cacti. This is useful when your directory contains a mix of users who should and should not be granted access to Cacti. For Cacti to require that the user be apart of a group, Cacti will send a <em>compare</em> request to the directory server asking the server if a specific group has any parameters that contain a specific username. As an example, a compare requests asks the following type of question:</p>
<p>Does there exist a group named <code>CN=cacti-admins,OU=Admin_Groups,OU=Groups,DC=corp,DC=company,DC=com</code>, attached to which there is an attribute named <code>member</code>, where the value of the attribute is <code>CN=Joseph,OU=Admins,DC=example,DC=com</code>?</p>
<p>The following three settings determine the content of the compare request.</p>
<ol>
<li><em>Group Distinguished Name (DN)</em> - The DN of the group into which the directory server should search for attributes. For example:</li>
</ol>
<pre><code>CN=cacti-admins,OU=Admin_Groups,OU=Groups,DC=corp,DC=company,DC=com
</code></pre>
<ol start="2">
<li><em>Group Member Attribute</em> - The name of the attribute into which the directory server should search for the user. For example:</li>
</ol>
<div class="sourceCode" id="cb2"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1"><span class="ex">member</span></a></code></pre></div>
<ol start="3">
<li><em>Group Member Type</em> - The format of the text string which should represent the user.</li>
</ol>
<h3 id="specific-search-settings">Specific Search Settings</h3>
<ol>
<li><p><em>Search Base</em> - The portion of the directory hierarchy inside which the server should perform the search. When the directory contains many objects, the time and resources required to search the directory are greater. The <em>search base</em> setting is useful to reduce the portion of the directory that is searched, thus increasing speed and reducing processor load on the directory server. This setting is also useful if you want to restrict access to Cacti to users who exist in a particular location in the director heierarchy.</p></li>
<li><p><em>Search Filter</em> - The criteria for which the directory server should search. Any parameters that the server is capable of understanding are permitted here. Cacti will perform a substitution for the phrase <code>{username}</code> in the search filter, and will replace it with the username. This field must be in acceptable LDAP syntax. A useful example of a search filter would be:</p></li>
</ol>
<div class="sourceCode" id="cb3"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">(</span><span class="va">sAMAccountName=</span><span class="dt">{username}</span><span class="kw">)</span></a></code></pre></div>
<p>But more complex filers are also permitted, such as:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode bash"><code class="sourceCode bash"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">(&amp;(</span><span class="va">sAMAccountName=</span><span class="dt">{username}</span><span class="kw">)(</span><span class="va">memberOf=</span>CN=<span class="ex">cacti-admins</span>,OU=Admin_Groups,OU=Groups</a>
<a class="sourceLine" id="cb4-2" title="2">,<span class="va">DC=</span>corp,DC=<span class="ex">company</span>,DC=com<span class="kw">))</span></a></code></pre></div>
<ol start="3">
<li><p><em>Search Distinguished Name (DN)</em> - The username of the service account with which Cacti will bind to the directory.</p></li>
<li><p><em>Search Password</em> - The password of the service account with which Cacti will bind to the directory.</p></li>
</ol>
<h3 id="ldap-cn-settings">LDAP CN Settings</h3>
<h4 id="mapping-an-ldap-user-to-a-cacti-user">Mapping an LDAP user to a Cacti user</h4>
<p>Cacti stores many personal preferences and settings into its database that make it easier to use Cacti. For example, the GUI Theme, the Default View Mode, and the User Language are a few of these user settings. These settings are not stored in the LDAP directory, so they are not returned in the LDAP response. Therefore, Cacti will create a local user identity for each LDAP user who logs in. When Cacti creates a local user, it can automatically populate the following two parameters from the LDAP directory. If Cacti sees a local user already exists, it will not attempt to update the user with values from the directory.</p>
<ol>
<li><p><em>Full Name</em> - The LDAP attribute name which contains a user's full name. Some common examples are 'displayname' or 'cn'.</p></li>
<li><p><em>Email</em> - The LDAP attribute name which contains a user's email address. One common example is 'mail'.</p></li>
</ol>
<h2 id="a-few-notes">A few notes</h2>
<h3 id="certificate-verification">Certificate verification</h3>
<p>When using LDAPS, a key and certificate must be installed on the directory server. When the client attaches to the server, it must make a decision to trust or reject the certificate that the server provided. The client will attempt to find the issuer of the certificate in a local repository of trusted certificate signers. If you install onto the directory server a certificate signed by an internal authority or a self-signed certificate, you will need to add the certificate of the issuer to the local repository on the Cacti server. If you do not, the client will surely reject the certificate, causing authentication to fail. To install a trusted certificate into the local repository, consult the documentation for the Operating System platform upon which you installed Cacti.</p>
<h3 id="search-result-reference-referrals">Search Result Reference (Referrals)</h3>
<p>In Microsoft's Active Directory, LDAP response messages may contain a referral to other directory servers. If you are using LDAPS and have installed a certificate on some LDAP servers and not others, LDAP lookups will fail intermittently because LDAPS negotiations will succeed with some directory servers while failing with other directory servers. If you are experiencing intermittent LDAP failures, ensure that the Cacti server has network access to all directory servers, and that all directory servers are properly configured.</p>
<h2 id="common-scenarios">Common Scenarios</h2>
<p>These following scenarios are designed to help you see the different ways to harness the power of LDAP and build a working LDAP configuration in your environment.</p>
<h3 id="a-small-office-where-everyone-has-access-to-cacti">A small office where everyone has access to Cacti</h3>
<p>In this scenario, a small LDAP directory contains users who are all granted access to Cacti (there are no users denied from Cacti). Some may be administrators, while others are read-only users.</p>
<p>To handle this scenario, start by creating a new local user in Cacti with read-only permissions. Name the user 'MyLdapTemplate'. Next, in Cacti's Authentication settings, set the <code>User Template</code> field to 'MyLdapTemplate'. Set the <code>Mode</code> to 'No Searching'. Set the <code>Distinguished Name (DN)</code> field to '{username}@example.com', where 'example.com' is the name of your domain. When any user logs in to Cacti, their password will be checked against the LDAP directory and they'll be granted access to Cacti with read-only access (from the LDAP template user). Once a new user logs in, Cacti will create a local user where the user's <code>Realm</code> is 'LDAP'. You may then optionally promote that user to an administrator by visiting the <code>Users</code> page, locating the account for the LDAP user, and granting additional permissions to that user.</p>
<h3 id="a-large-office-where-you-only-want-a-subset-of-users-to-access-cacti">A large office where you only want a subset of users to access Cacti</h3>
<p>In this scenario, a large LDAP directory contains a mix of users who should, and should not, be granted access to Cacti.</p>
<p>There are two ways to handle this scenario. You may either manually authorize users within Cacti, or you may use a group in the directory to define the authorized users.</p>
<p>To handle this scenario by manually authorizing users within Cacti, navigate to the Authentication settings, and set the <code>User Template</code> field to 'No User'. Set the <code>Mode</code> to 'No Searching'. Set the <code>Distinguished Name (DN)</code> field to '{username}@example.com', where 'example.com' is the name of your domain. Next, navigate to the <code>Users</code> page and create a new user where the username matches the username in the directory. Set the user's <code>Realm</code> to 'LDAP'. Grant your desired permissions to the user. When that user logs in to Cacti, their password will be checked against the LDAP directory and they'll be granted access to Cacti based upon their local account.</p>
<p>To handle the large office scenario by using group membership, start by creating a user in the directory that can be used for searching the directory (this is sometimes referred to as a Service Account). Under normal circumstances, this directory user does not need elevated permissions. Next, create a group in the directory that contains all the users who should be granted access to Cacti. Next, in Cacti, create a new local user named 'MyLdapTemplate', with administrator permissions. In Cacti's Authentication settings, set the <code>User Template</code> field to 'MyLdapTemplate'. Set the <code>Mode</code> to 'Specific Searching'. Leave the <code>Distinguished Name (DN)</code> field blank. Set the <code>Require Group Membership</code> field to enabled. Set the <code>Group Distinguished Name (DN)</code> to the name of the group. Set <code>Group Member Attribute</code> to 'member'. Set <code>Group Member Type</code> to 'Distinguished Name'. Set <code>Search Base</code> to the DN of the hierarchical structure in the directory which contains all the users, such as 'OU=Users,DC=example,DC=com'. Set <code>Search Filter</code> to 'sAMAccountName={username}'. Set <code>Search Distinguished Name (DN)</code> to the username of the service account you created in the directory. Set <code>Search Password</code> to the password for the service account. Optionally, set <code>Full Name</code> to the directory attribute that contains the user's name, such as 'cn', and also set <code>Email</code> to the directory attribute that contains the user's email address, such as 'mail'.</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
